<h1>MagicWand</h1>

<h6>The plugin is available in the QGis public repository:
    <a href="http://plugins.qgis.org/plugins/MagicWand/">
    http://plugins.qgis.org/plugins/MagicWand/</a>
</h6>

<p>MagicWand is a QGis plugin written in python. The plugin adds a toolbar
that contains three actions.</p>

<h2>Magic wand tool <img src="icons/magic_wand.png"/></h2>
This action activates a mapping tool that allows the user to extract a
polygon from an image with just one click, depending on the pixels' colors.
<br/>
<b>Required:</b>
<ul>
<li>Active layer in the legend must be a <b>raster layer</b></li>
</ul>
<b>Usage:</b><br/>
Click a specific element on the raster layer (i.e. click on a red roof
of a building that is surrounded by a green field). The tool generates a
polygon that represents the clicked element (the roof) and stores it
instantly in a temporary layer.<br/><br/>
The created polygon is automatically selected on the temporary layer.
If the user is satisfied he/she can just <b>press enter</b> and the polygon
 will get unselected.<br/><br/>
If a generated polygon result is incorrect it can be <b>edited</b>. In order to edit an existing polygon
just select it (if it is the last thing that was created then
it is already selected by default) and press a point close to the polygon. <br/><br/>
Furthermore, if the user <b>left clicks</b> a new area of pixels with
similar colors, it is going to be <b>added</b> to the already existing and selected polygon.
On the contrary, if the the user <b>right clicks</b> on the area, it is
going to be <b>subtracted</b>.

<h2>Magic hat tool <img src="icons/magic_hat.png"/></h2>
This action activates a mapping tool that allows the user to edit an existing
polygon on a vector layer.<br/>
<b>Required:</b>
<ul>
<li>Active layer in the legend must be a <b>vector layer</b></li>
<li>One and only one feature <b>must be selected</b> in the vector active layer</li>
</ul>
<b>Usage:</b><br/>
Click and hold in the map to draw an outline that represents the part of the polygon
that you want to add or delete. <br/>
Use <b>left click</b> in order to add a part to the existing polygon. A <b style="color:green">green</b>
outline will be displayed.
Use <b>right click</b> in order to delete a part of the existing polygon. A <b style="color:red">red</b>
outline will be generated.

<h2>Settings <img src="icons/settings.png"/></h2>
This action pops up a settings dialog. The following properties can
be set: <br/>

<b>Tolerance</b><br/>
Tolerance is used to understand if 2 blocks of pixels have similar colors.
Example: If the user decides to extract a light green field surrounded by dark green trees  to
a low value of tolerance must be set.
Conversely, if a field that has different shades of yellow is selected to be extracted
all at once, the tolerance must be set to a high value. <br/>

<b>Approximation</b><br/>
Approximation is used by both the MagicWand and the MagicHat.<br/>
In the <b>MagicHat</b> it determines simply the brush thickness.<br/>
Instead, in the <b>MagicWand</b> it determines how many pixels must be merged
in order to speed up the process. If approximation is increased you will
immidiatly notice that the trasparent white area that follows your cursor
is increased. <br/>
Examples (MagicWand): Increase approximation if you are working on a big scale, if you want
to extract a huge element in relation to the pixel size in the raster layer
or if the process becomes slow. <br/>

<b>Timeout</b><br/>
A <b>MagicWand</b> task can last at most the time indicated in the
timeout properties. If a task is taking more than the timeout value
(by default 15 seconds), it will be interrupted.

<b>ViewSteps</b><br/>
Is a boolean that is used mainly in debbug mode but can be used also
in order to understand how the <b>MagicWand</b> tool works. When it is
activated, the algorithm's process is shown.
<p>

<h2></h2>
Tested on Windows, QGis oldest version tested 2.9.
</p>
<p>
Credits to: Ginaluca Silvestri
</p>